scan_kk_eng

SCAN_KK [image] [image] (c) by Mike ;-)

Welcome to Scan_KK :-)

What's up with Scan_KK?

Scan_KK can be used to cut out and save small fixed (but selectable) pieces from a larger
scanned or photographed bitmap.

=> [image] +

I developed it, to get the crown cap pictures for my caps lists and my trading section on
my homepage ( www.twus.de ).

I put the crown caps on a scanner and save the pictures in the BMP-format.
In my caps lists I had selected 180 x 180 Pixel a long time ago.
With normal graphics programs it is a fuzz to get always the same size cut,
so I developed Scan_KK :-)

The program name was selected, because I wanted to let the program do the scanning itself.
Finally this feature is implemented (since V1.01) and the name is program ;-)

Mike's Scan_kk, Copyright ©
e-mail: info@twus.de - WWW: www.twus.de.
Michael Demuth - All rights reserved.


Features

Features: SCAN_KK [image] [image] (c) by Mike ;-)

Scan_KK has the following features:

  • Scan_KK is freeware or in other words: crown caps ware (see License)
  • input format: BMP and JPEG (24-bit)
  • get previous/next picture with a click/key press
  • select from the last loaded files
  • if enabled: automatically load the last loaded picture / the 1. picture in the last directory
  • output format: BMP, JPEG
  • scanner support (colo(u)r only) (including cameras etc.)
  • selectable picture size
  • selectable sharpening
  • selectable depth of the sharpening (with preview)
  • selectable (manual or automatic) copy of the preview picture to the clipboard
  • selectable second copy of the cutted picture with different size and destination
  • 3 different presets can be saved and quickly selected
  • rotation of the selected picture with a mouse click (right mouse button)
  • moving of the selected picture with a mouse click (left mouse button)
  • manual or automatic naming of each picture
  • offline help
  • selectable language: english, german
  • fit larger pictures to actual program window size (configurable)
  • automatic movement of the preview picture if it is partly outside the mointor view (configurable)
  • configurable scaling of the picture after scanning
  • update function

Mike's Scan_kk, Copyright ©
e-mail: info@twus.de - WWW: www.twus.de.


Requirements

Requirements: SCAN_KK [image] [image] (c) by Mike ;-)

Requirements for Scan_KK:

  • Windows 7 (min. SP1) and 8.x and 10 and 11 (Windows 95 to NT and Windows XP and Windows Vista are not supported any longer by the installer)
  • The setup does need Administrator credentials.
  • memory (harddisk): about 13 MB
  • RAM: depends on input bitmap size (16MB, tested with 1024MB and 2048MB and more)
  • installed TWAIN-driver (only if the scan-function shall be used)
  • source pictures in BMP- or JPEG-format (24bit colo(u)r depth)
  • Internet-Explorer >= version 4.0 => Hey people: please update ;-)
  • a screen resolution of >= 1024 x 768 pixel (only to see the complete help text in the status bar)

Mike's Scan_kk, Copyright ©
e-mail: info@twus.de - WWW: www.twus.de .


HowTo

HowTo: SCAN_KK [image] [image] (c) by Mike ;-)

How to use Scan_KK:
  • First do the settings (3 different sets are saveable)
    (under "     Options " => "Settings..." or press "Ctrl-E") - which will survive a program restart.
  • Select one of the 3 presets (menu => "Preset 1(..)" to "Preset 3(..)")
  • Than load the bitmap (BMP or JPEG) of the eg. crown caps (under "File" => "Open" or press "Ctrl-O" or select under "File" one of the last loaded files).
  • or click "<<" or ">>" or press "Alt-<" or "Alt->" to load the previous or next picture
  • Or acquire a bitmap (under "Acqusition")
  • To cut out a picture, use the left mouse key with a double click into the center of the wanted picture area.
  • if the picture is out of center or rotated, it is easy to do the needed corrections.
  • use the next double click to cut out the next picture etc...
  • for still more help there are some options.


Settings

Settings: SCAN_KK [image] [image] (c) by Mike ;-)

Settings-Dialog Scan_KK :

Settings dialog

User-Presets:
 Select one of three presets (tab on top) to change its values. When this dialog is started always the active
preset is selected.
All further changes are made only for the selected user-preset!

Preset-Name:
 To remember what one user-set is for: give them a name (max. 14 characters) as preset name.

Grafics-Settings:

Output-Format:

  • save pictures in the formats JPEG (with the file extension: JPG) or BMP

JPEG-Quality:

  • 0% (worst quality=smallest filesize) to 100% (best quality=biggest filesize)
  • recommendation: 85%

Size-X and Size-Y:
  • dimensions of destination picture in pixel

Save-Dir.:
  • directory on harddisk to save the destination pictures to
    "." saves the pictures always to the path where the input picture is opened
  • click on Path, to enter a new path

Adjustment:

The picture in the preview window can be moved by holding the left mouse button and can be rotated by
holding the right mouse button.
The changes created with the movement of the mouse can be adjusted here (movement in pixel, rotation in degree),
to adapt to the speed of the used PC.

Holding the "Ctrl"-key during mouse movement, the movement or rotation of the picture uses the second set of values (named: fast).

The default values are:

  • move normal: 1 Pixel
  • move fast (+ "Ctrl-key"): 5 Pixel
  • rotation normal: 1 degree
  • rotation fast (+ "Ctrl-key"): 4 degree

Automatics:

Automat. load pic at startup:

  • select to load a picture automatically at program startup from the last used directory (if the pictures still exists) .

=> last picture

  • if one selects "last picture" too, Scan_KK tries to load the last loaded picture at programm startup.

Automat. center picture

  • Without function yet: centering the crown cap in the preview window automatically.

Center preview:

  • the preview window is centered on top of the double click position of the main window.

Extras:

Tooltipps:

  • if checked: if the mouse cursor stays a little time over an component a little help text is shown.

only 1 instance:

  • if checked: only one instance of Scan_KK can be started.

Verbose info on titlebar:

if unchecked: the main window shows the following information::

  • program name with version (eg. "SCAN_KK V1.07")
  • active preset (user preset) with name (eg. "Preset 2 (Mike)")
  • name of the loaded file
if checked: the main window shows the following additional information:
  • Dimensions (x * y * color depth)
  • Status autonaming (autonaming with counter #: xx)
  • Status AutoloadLastPic (at program start)
  • Status Autocenter
  • Status Adjust

Copy to clipboard:

  • select to copy each picture in the preview window automatically into the clipboard (for easy import into other programs).
  • don't select to copy a picture in the preview window manually into the clipboard by typing "Ctrl-C" oder "Ctrl-Insert".

Preview of too big pictures:

  • select to show pictures, which does not fit into the program window, complete on a preview window, when the mouse pointer
    hovers over the menu entry "*.bmp(x/y)" or "*.jpg(x/y)" or "*.jpeg(x/y)" (see Preview).

Fit pictures to window:

  • select to automatically fit each picture, which does not fit into the program window to the program window.
    The picture preview (even if enabled) will not show up!

Remember position (alle Presets):

  • Scan_KK will have the same size and position on next startup (all presets have the same value)

Sharpening:

To sharpen the new picture.

Sharpening strength:

  • select strength of sharpening => viewable in the two windows: "original" and "preview"
    (the shown pictures will only be seen, if one has not yet double clicked to get an own cap)
  • move slider to the left => lesser sharpening
  • move slider to the right => more sharpening

Sharpen:

  • select to sharpen each output picture

Alignment-Helplines:

  • in the preview window alignment helplines are shown
    as soon as Ctrl and "y" is pressed.
  • Here you can adjust the width, spacing (in pixel each) and color of that lines.
  • Color settings: Farbeinstellung
  • pressing Strg and "y" again removes the help lines.

Border Fill Color:
  • shows the color, which the program uses at the borders of the source picture as a background filling color
  • click [image] to set the background filling color to white
  • click [image] to set the background fill color (the color dialog openes - see above)
  • or: hold the "Ctrl" key and make a double click with the left mouse button into the main window on the
    wanted color to select a new color
  • Example: rotated =>

Scan-Input: set new size as percentage of original:

Width and Height :

  • gives the factor for the scaling of the direct scanned picture only.
    With 100% by 100% the program leaves the picture untouched.

Second Copy:

Size-X and Size-Y :

  • dimensions of destination picture in pixel for the second copy of the pictures.

JPEG-Quality:

  • 0% (worst quality=smallest filesize) to 100% (best quality=biggest filesize
  • recommendation: 85%

Save-Dir.:

  • directory on harddisk to save the second copy of the destination pictures to.
  • click on Path, to enter a new path for the destination of the second copies.

OK:
  • leave the settings dialog with saving of all changes.

Cancel:
  • leave the settings dialog without saving of changes.

Apply:
  • the new values of the selected user-preset are saved (without leaving the dialog)
    (the button is only enabled after a value is changed).
.
To use the keyboard to select the different options use the ALT-key together with the underlined
letter (eg: ALT+R to reset the border fill color to white).


Open

Open: SCAN_KK [image] [image] (c) by Mike ;-)

Load the source picture with the crown caps (under "File" => "Open") or press "Ctrl-O".

Depending on the format of the opened pitcure (bmp or jpg/jpeg) all bmp- or jpg/jpeg-pictures in the selected path (see Settings) will be shown.

Only JPG/JPEG pictures with a size bigger than a selectable level (see Settings) will be shown to differentiate between input and output files

(see: "Filter JPEG for fast selection: Threshold in kB").

Select one picture, which will be shown in the main window (completely if "Fit pictures to window" is selected) .

Holding down the Shift-key while opening a picture, the new picture will be shown in the same position as the old one (if possible) .

If the picture does not fit into the window, one can scroll it with the arrow keys, the keys "Pos.1", "End", "Page up"
or "Page down" or with a mouse wheel, if such a mouse is connected to the PC.

If the "Ctrl" key is held while scrolling with a mouse wheel, the picture will be scrolled to the left or right.

Further possibilities to open a fileor edit the "recently opened file list":

Under "File" one can open - with a mouse click - older files (see 3.) which have been loaded before (if they are still existent).

The file list can be completely erased with a click to "Recently used files (=> clear list)..." (see 1.).

Accept to clear the list.

Files that are long gone can be cleaned from the list with a click to "Recently used files (=> clean list)..." (see 2).

Accept to clean the list.

Clicking on "<<" (see 4.) or ">>" (see 5.) will automatically load - if present in the directory - the previous or next file.

For JPG-files a size threshold must se set under Settings for the JPG-file to show up after clicking << or >>.

Second Copy

If a valid path is given in the setting dialog for "Second copy", the preview window has a new checkbox (see green rectangle in the picture below).

When this checkbox is checked, a second copy of the cutout picture with the selected size (Second Copy: Size-X, Size-Y) is saved at the given harddisk
position (Second copy: Save dir) when the "Save"-Button is clicked.

For example the main picture will be saved with 180x180 pixel in the current directory and the 2. copy with 110x110 pixel under e:\work\hp_twus\tauschkk
with a click on "Save".


Cut

Cut: SCAN_KK [image] [image] (c) by Mike ;-)

To cut out a picture, use the left mouse key with a double click into the center of the wanted picture area:

The selected picture (here in 180x180 pixel) is shown in a preview window (sharpened if selected in active Preset 1).
You only have to enter a name (here "robinson") (an automatic naming is possible too) and to
press "Save" (or hit the return key).

To show that the output picture is saved the save-button will be disabled (grayed-out).

A double click on the name "path" will show a dialog to select a new path.

If a correction is made or "File" => "Save" is selected or "Ctrl-S" is pressed, the save-button will
be enabled again.

You can repeatedly save the file without any question from the program, the saved version will be overwritten automatically.
But if you make a new double click, the program verifies, if the older version shall be overwritten.

If "Top" is selected, the preview window will stay on top of all other windows.


Corrections

Corretions: SCAN_KK [image] [image] (c) by Mike ;-)

If the crown cap has not the correct orientation (happens easily putting them on the scanner),
there is a new method (since V1.06) for the corrections: the Drag-Modus!

The Click-Modus of the older versions isn't supported anymore (personal experiences) !

The Drag-Modus:

In the Drag-Modus you have to click with the left or right mouse button into the preview
window, hold the button down and move the mouse around.
With the pressed left mouse button the picture can be moved around, with the pressed
right mouse button the picture can be rotated clockwise (moving the mouse to the right)
or counterclockwise (moving the mouse to the left).
The mouse pointer changes to show, if the the movement-modus ( [image]) or the rotation-modus
( [image]) is active.

Holding down the key Ctrl uses different change values (under " settings " => Adjustment-Values) .

With the keys "Ctrl-L", "Ctrl-R" or "Ctrl-F" the picture will be rotated by -90°, by +90° or by 180°.

If you press Ctrl and "y" the vertical and horizontal alignment helplines (green Lines: under "settings" =>
set color, width, spacing) will appear.
They shall help in the correct alignment of a crown cap. To move the lines press Ctrl and "u", Ctrl and "d",
Ctrl and "m" or Ctrl and "p" to move the lines up, down, left or right.
Press Ctrl and "y" again to remove all alignment lines.

Align the lines to features of the crown cap and make the adjustments to the picture as usual.

After rotation and/or movement enter the name of the output picture or press "Save" or hit the return key.

General:

All key shortcuts are shown at the bottom of the main window.

If tooltips are enabled (under " Options" => "Settings...") move the mouse pointer over the "?"-button (1.) and
wait.
A small window with hints will appear: Hinweis

If "Top" (2.) is selected, the preview window will stay on top of all other windows.

Double click on "Path" (3.) to enter a new destination path for the picture to save.

Under the hood :

A double click into the main window copies an area of 4x the size into PC memory and the central part is shown in the preview
window.
If the picture is moved with the left mouse button, a new copy from memory (with changed distances) to the display
is made.
When the left mouse button is released (or the border of the 4x area is reached), a new 4x copy from the main window
to the PC memory is done.
During rotation with the right mouse button the sharpening is done only when the right mouse button is released, because of
speed reasons.


Options

Options: SCAN_KK [image] [image] (c) by Mike ;-)

If "Options => Auto-Name" is marked, Scan_KK will only ask once for a name of the output picture.
For the next pictures Scan_KK will automatically add a counter value (4 digits) to the name of the
output pictures .
The counter is incremented with each picture. To start with a counter of zero or any other value, select
"Options" => "Set Auto-Name counter", enter a value (only 4 digits) and press "Set" or press "Clear" :

 Optionen

If "Auto-Name" is active (shown by a mark in the "Options" menu), the save-button in the preview window will
be disabled (not for the first start of the preview window), to show that the
picture already has been saved with the double click. If one wants to save the picture under a new
name or one wants to do corrections, please select "File => Save" or press "Ctrl-S" or click into the
preview window and the Save-Button will be enabled again.

Options

If one selects in Scan_KK under "Options" => "Delete Scan_KK in Registry ...", all entries of Scan_KK in
the registry will be cleared. This will be done by the uninstaller of Scan_KK too.

To select one of the three setting presets: please select under "Preset x(..)" the one you like.
The active preset (with the given name) is shown on the titlebar and used for the preview picture.
Furthermore the active preset is enclosed in "***".

 To start an update of Scan_KK press the button "Update..." (see Updates) .


Acquisition

Acquisition: SCAN_KK [image] [image] (c) by Mike ;-)

To use Scan_KK to acquire pictures directly, first select a scanner source under
"Acquisition" => "Select device" (or use <Ctrl-Q>).
This can be a scanner, a camera, a web cam or any capturing device with TWAIN support.

acquisition

Source selection example (here shown with a german Windows XP):
Auswahl Scannerquelle

After this one can start the acquisition under "Acquisition" => "Acquire..." (or press <Ctrl-A>).
The scanner acquisition menue will show up. You have to select the area etc. and start the scanning.
In the moment Scan_KK only supports colo(u)r scans!
The percent values behind <Ctrl-A> show the scale factor applied to the picture after the scan procedure (direction X by Y).
The values can be set under "Settings".
When the acquisition is completed the picture will show up in the main window of Scan_KK and
can be saved under "Acquisition" => "Save input picture..." as BMP-file.
Now one can normally cut out pictures with a double click.

As long as no previous picture has been loaded manually, Scan_KK will ask after the 1. double click
into a picture from a scanner to get a save path for the cutout pictures from the user.
After that one can change the path with a double click on "Path" in the preview window.


Languages

Languages: SCAN_KK [image] [image] (c) by Mike ;-)

To select another language in Scan_KK select a new one under "Language".

In the moment, if in Scan_KK "german" is active, only "english" and if in Scan_KK "english" is active, only "german" can be selected.

After confirmation Scan_KK will exit and restart automatically.

Eventually the restarter program is visible for a short time:

Possibly you may have to restart the program yourself! Please see FAQ.


Preview

Full Picture Preview: SCAN_KK [image] [image] (c) by Mike ;-)

If the loaded picture doesn't fit into the program window, a preview of the whole picture will be shown,
when the mouse pointer hovers over the menu entry "*.bmp(x/y)" or "*.jpg(x/y)" or "*.jpeg(x/y)" (see mouse pointer in the picture).
When the mouse is moved or a click into the preview window with the right mouse button is done, the preview
is removed (as long as the mouse pointer is in the program area and not in the "*.bmp(x/y)" area!) .

A double click with the left mouse button in the full picture preview window does the same as a double click in
the main program window does: it shows the preview window of a singel cap. So you don't need to scroll in
the main window to the desired cap and double click there ;-)

Together with the entries to select another picture in the current directory ( "<<" and ">>") you
can get a quick overview, if the desired crown cap is on the current picture without the need to scroll
down or move the mouse a lot.

You can disable this preview feature in the settings dialog ("Preview of too big pictures")!

If "Fit pictures to window" is activated, the preview will not happen even if enabled, but instead the whole picture is shown in the program window.
The creation of a single cap preview with a double click is than possible too.


HowTo

HowTo: SCAN_KK [image] [image] (c) by Mike ;-)

Update Scan_KK:

If the updater was selected during the installation process of Scan_KK, one can start under
"Options" => "Update..." a program update. After a check :

the helper program M_updater.exe will be startet!

If the user has no administrator rights and the UAC (User Access Control) is not deactivated, Window
(from Windows Vista on) will present an dialog to log on as administrator. Please sign on here as an
administrator or the installation of the update will fail later on.
Is the UAC deactivated, no dialog will pop up and the later installation of the update will fail!
It is possible to continue the update without any administrator rights until after the download of the
setup file and to later on install it under an administrator account. It is adviced than to use the detailed mode
to see where the setup file is saved on the PC.

If you press the button "Next >", you will come to the options dialog for the connection properties:

After selection of the proxy settings and the selection (under "Mode") if you want detailed or not so detailed
information during the update process, you will get with "Next >" to the main update dialog:
(with the button "Save settings" you can save the information for the next update)

Detailed mode:

Easier mode:

Under "Step 1 =>" you can check the server for a new version. Not a single informationen is sent to the server,
only the information file for Scan_KK is fetched from the server:

Is the file on the server newer you get the following information box:

Information about the version on the server is shown:

A right mouse click enables the user to select all entries in the information box (or use Ctrl+A)
and to copy them into the clipboard (or use Ctrl+C):

You can get the new setup file from the server with "Step 2 =>" and get a new information box:

If you start the install process under "Step 3 =>", M_updater will stop itself and the new setup file from the server starts.

In the first dialog you can select the language for the installation. During an update the language of Scan_KK is preselected.
Press "OK" to continue:

After a short Splash screen, read the disclaimer and select "I accept the agreement" and press "Next" to continue:

Install 2

Read the information and press "Next" to continue:

Install 3

Change the path as you like (with "Browse...") or leave as suggested and press "Next" to continue:

Install 5

If the program is already installed in the selected path, a warning will be presented when "Next" is clicked.
You can change the path by selecting "No", but it is advisible to use the old path by clicking "Yes".

Install 5

If you deselect the addon in the next window, it will later not be possible to check from within Scan_KK if new program versions
are available. You have to visit www.twus.de by yourself and take a look. I suggest to leave the checkmark selected and to press "Next" to continue:
Internet update will not send any personal data of you to the world!! An Info file will loaded from www.twus.de, to check if a new version is available there.

Install 6

If the checkmark at "Addon..." is removed, the program will give a warning and enables the user to change the
setting by pressing "Yes":

Warnung

In the next dialog: give a new folder name for the start menu or leave as is set and press "Next" to continue:
(Hint: it is advisible to set no mark at "Don't create a Start Menu folder"!)

Install 7

Now you can decide, if you want a desktop icon to be set or not. That will apply for all users!
Press "Next" to continue:

Install 7

Verify if all options are as you like and press "Install" to install the new version of Scan_KK
to your PC:

Install 8

After completion you can use your new version of Scan_KK :-)


License

License: SCAN_KK [image] [image] (c) by Mike ;-)

License of Scan_KK:

Scan_KK is "crown-caps-ware" - this means that Scan_KK is freeware, but I would be happy to get some crown caps for my efforts, donations I would not refuse either ;-)
I would like to hear from people using it, suggestions, wishes and bug reports - please send emails to info@twus.de ).
The latest version of Scan_KK can be found at www.twus.de .


History

History: SCAN_KK [image] [image] (c) by Mike ;-)

Versions of Scan_KK:

28. July 2002 0.1
start with versions with other graphic library in demo-mode

Beginning 2007 V0.9x
first internal versions with FreeImage graphic library

11. August 2007 V1.00 Beta
first official release

23. November 2007 V1.00
1. enable save-button after rotation or moving of preview picture
2. improve functionality of the scrollbars (Thanks for the tip goes to Rudi Mende)
3. enable scrolling of the picture with arrow keys & Home & End
4. for rotation >90 degrees the point to click was wrong (diogonal movement)
5. show help lines (with characters) in the preview window for movement
6. checkbox for the preview window => to enable or disable it to stay on top of all windows
7. scroll picture down => minimize => maximize => picture is no longer scrolled back to the top
8. Hotkeys (eg. Open file => Ctrl+O, open settings => Ctrl-E, exit program => Ctrl-X)
9. scroll picture with Mousewheel
10. save three different Settings (Thanks for the tip goes to Rudi Mende)
11. close preview window as soon as "open file" is selected
12. close preview window with "ESC" key
13. mirroring (180 degrees) and -90 degrees and +90 degrees (with Hotkey (Ctrl-F, Ctrl-L, Ctrl-R))
14. tooltip correction (height of titelbar)
15. no more flickering during scrolling and sizing
16. show "wait cursor" during rotation of the picture
17. clear old registry values of the beta version
18. link to FreeImage project (in About window) made clickable
19. added tooltips for preview window
20. Help reworked
21. Freezing with double click and no loaded image corrected

27. December 2007 V1.01
1. Fix: open a new picture => jump to top of picture
2. New: Tooltipps deactivatable (in Preview too)
3. New: Scan functions implemented
4. Fix: allow Ctrl-O and Ctrl-E, even if the preview window is active
5. Fix: exit program as maximized => Start => program is maximized again
6. Fix: help reworked
7. Fix: smaller internal things fixed
8. New: deupad-file created
9. Fix: Access violation with Ctrl-E shortly after program start corrected
10. Fix: the preset name was not shown on the title bar after a new selection (only after leaving settings)
11. New: show info text for Ctrl-L,R,F in the status bar
12. Fix: the preview picture happens to be sometimes no longer centered after Ctrl-L,R,F
13. New: Automatic restart after a new language is selected
14. Fix: picture corrupted after switch from small window to maximized window

05. Januray 2008 V1.02
1. Fix: start maximized if (under settings) "remember Pos." is not selected
2. New: input file format JPEG is now supported (Thanks for the tip goes to Kamil Kamiński)
3. Fix: Dialog for new registry-entries reworked
4. Fix: 2 starts were needed after first installation
5. Fix: Help reworked
6. Fix: Autonaming is no longer the default for first installation
7. Fix: scrollbars were missing after acquisition of a long picture
8. Fix: name not shown on titlebar after acquisition and saving of a picture

21. October 2009 V1.03
1. New: more helplines in preview window for alignment (with selectable width and spacing)
2. New: helplines in preview window moveable for easyer alignment
3. Fix: Autonaming corrected
4. Fix: remember used file load format (BMP or JPG) during program run
5. New: show new loaded picture in same position as old one (if "Shift" is pressed during selection)
6. New: 256bit Icons (for Vista)
7. New: select presets on top menu level
8. Fix: Help reworked
9. Fix: picture was mirrored with TWAIN-accquisition - due to newer graphic library (thanks to Nils and Jürgen)

20. December 2009 V1.04
1. Fix: Icons with transparence
2. New: Possibillity to select previous/next picture with a key press
3. New: automatically load last loaded picture at startup
4. Fix: updated installation procedure
 5. New: show most recently used files (to select for new loading)
6. Fix: Auto-Naming was not ok
7. New: copy preview picture automatically or manually into clipboard (thanks to Eckhard for the idea :-))

20. August 2010 V1.05
1. New: inhibit installation/uninstallation as long as the program is running
2. Fix: open-file-dialog and save-file-dialog were not working under Win98
3. New: when saving input-picture (under Acquisition) => copy to last recently used file list
4. Fix: picture reload at startup => Scrollbar was missing
5. Fix: if window is fullscreen => scroll down => minimize => restore => window scrolls to top
6. New: new version FreeImage (3.13.1)
7. New: settings dialog and storage mechanism in registry completely reworked
8. New: new way (DRAG_MODUS) to correct picture orientation (with the mouse)
9. New: show picture index and number of all pictures in current directory eg.: "3/5 (*.bmp)"
10. Fix: if preview window stays on top => nevertheless show messages in the foreground
11. New: Neues Icon des Einstellungsdialoges

09. November 2012 V1.06
1. New: changed internal proceedings (advantage for slower PC)
2. Fix: start value of sharpening previews were not shown in settings dialog
3. New: new version FreeImage (3.15.3)
4. Fix: selection of working modus removed in settings dialog
5. Fix: icons of the settings dialog disappear at 2. call
6. Fix: autonaming not working
7. New: button "Clear" added in autoname dialog
8. New: added adjustment values in settings dialog
9. New: dropping file on scan_kk icon will open the file (command line parameter)
10. New: clean up list (File pulldown menu => recently used files) (with question)
11. New: addded question at => clear list (File pulldown menu => recently used files) löschen
12. New: first version updater integrated
13. New: show complete picture (preview) if it is too big

26. November 2014 V1.07
1. New: Doxygen documentation
2. Fix: "open with..." corrected
3. Fix: column "Key" on display of loading error registry made wider for longest key (LastOpenedFileModus)
4. Fix: if window is maximiert, restored or resized => reload of actual file to fit it into new window
5. Fix: during fitting of too big pictures: obey dx and(!) dy
6. Fix: window on 3. monitor (right), not maximized => Restart => Window still on 3. monitor but too small => fixed
7. Fix: if setting "fit pictures to window" => refresh in main.c, to show changes immediately
8. New: load Jpg with preview and fit to window (like bmp)
9. New: select Jpg with << or >> (set threshold in setting dialog, to avoid output files to show up)
10. Fix: load Jpg, than load bmp (or vice versa) => wrong display (<< *.jpg/2/2 >> and wrong index)
11. New: new version of FreeImage (3.16.0) used
12. Fix: quit windows Autoname-Counter, About and Settings with ESC
13. Fix: *.jpg was not loaded automatically at startup
14. Fix: if "Fit pictures to window" is selected => at opening a *.jpg is not shown
15. Fix: test "Fit pictures to window" awith scanning! (main.c => FreeImage_Rescale()) ok
16. New: give the possibillity of (configurable) scaling during scanning
17. New: show scaling values (in %) in the menu after (Acquire) ...<Strg-A>
18. New: preview window: not only show help text but complete path (if path is too long for the field to show in)
19. New: picture Scanning => Acquisition => Save input picture ==> use path as destination path for pictures to save (after double click)
20. New: updater reworked and activated (storage of settings for caller Scan_KK)
21. Fix: safer functions used (strcpy_s, scanf_s, strnlen_s, and so on)
22. New: if preview window is partly outside of the monitor => make it visible (option in settings dialog)
23. Fix: tooltipps for main buttons settings dialog enabled
24. Fix: setup reworked and test with Win8.1 and Win10 Technical Preview
25. New: right mouse key enabled (for selection and copy into clipboard) in updater infobox enabled
26. Fix: messagebox at start of update more detailed
27. New: only 1 instance of Scan_kk (settings option)
28. Fix: more clear information in installer that without the addon no update out of the program will be possible
29. New: call setup with language preselection (german or english or asking)
30. Fix: Validity check reworked
31. Fix: corrected tip => Ctrl (instead of ALT) key, to pick up color
32. New: tested with Win8.1 and Win10 Technical Preview
33. Fix: Color selector made modal, to disable multiple starts of it
34. Fix: selecting "Acquire" anwählen and than "Cancel": cleared old picture

27. November. 2014 V1.08
1. Fix: get version information from resources (Title and About)

16. August 2018 V1.09
1. Fix: correct overlay lines and overwrite in AnzeigeDlg()
2. Fix: correct PaintOverlayHelpLines()
3. Fix: close handle in Save() in case of a failure

07 February 2021 V1.0.10beta
1. Fix: change compiler to PellesC V10
2. Fix: remove warnings at strcpy() and strcat() by cast to (void)
3. Fix: in some directories the change between some *.bmp does not work => corrected in sort_names()
4. Fix: changed version from 1.x to 1.0.x

26 September 2021 V1.0.10
1. New: save Jpeg pictures in progressive style (will load faster on homepage)
2. Fix: center scanned picture on double click point
3. Fix: transfer scanned picture centered to result (output picture)
4. Fix: change compiler to PellesC V11
5. Fix: go back to 32bit (due to IDE: debugging with PellesC V11)
6. Fix: use _stdcall as calling convention (to avoid unresolved externals for FreeimageLib)
7. Fix: use DLG_ANZEIGE (instead of DLG_ABMESSUNG) to measure the output dialog
8. Fix: use Innosetup 6.2.0 to create the setup file (Windows XP is not supported any longer)

07. April 2022 V1.0.11
1. Fix: preview window was size limited (introduced with V1.0.10)
2. Fix: positioning of the picture in the preview window improved (for all selected x*y sizes)
3. Fix: preview window lost position when "Center Preview" was not selected
4. Fix: measure size of output dialog no longer via DLG_ANZEIGE
5. Fix: corrected texts
6. New: show info when user double clicks into the picture with holding the Shift key that background color has been selected
7. New: path and sizes made changeable for the second copy (selectable in the preview window) (default was: 110x110 and e:\\work\\hp_twus\\tauschkk)
8. New: if an error occurs during registry loading (macros: GETREGVALUExxx) the index of the offending entry is shown
9. Fix: update of the setup
10. Fix: update of the updater (now V1.0.1)

20. July 2022 V1.0.12
1. Fix: check of directory flags corrected
2. Fix: files with the extension bmpx or jpgx were recognised erroneously as pictures
3. Fix: do not clip text on statusbar (below)
4. New: show Build-No. on the titlebar
5. New: update Innosetup to 6.2.1
6. New: open files with the extension jpeg
7. Fix: save setting for "Preview of too big pictures" again
8. New: successfully tested on Windows 11
9. New: made JPEG-quality of second copy changeable
10. Fix: if menu was multiline, preview window was displaced (after double click into the picture)
11. Fix: it was not possible to double click near the preview window
12. Fix: several changes to avoid DLL attacks
13. Fix: changed the name in the Autoname dialog: from "Set" to "Accept"
14: Fix: Doxygen: removed warnings for functions returning void
15. New: animate taskbar icon of the program when using "about"
16. Fix: on preset selection the percent value under "Acquisition=>Acquire" was not changed
17. Fix: update of the updater (now V1.0.2)

Ideas for future versions:
 1. Fix: remember last selected TWAIN-device for next program start
2. New: colorize picture parts afterwards (toolbox)
3. New: show former save names in preview window when typing ahead
4. New: automatically center caps in the preview window


Author

Author: SCAN_KK [image] [image] (c) by Mike ;-)

The tool Scan_KK was written in C by Michael Demuth, 22962 Siek, Hauptstr. 45b, Schleswig-Holstein, Germany.

I used "Pelles C for Windows" (Homepage Pelle Orinius).

The latest version of Scan_KK can be found under www.twus.de.

There you can find the clockprogram T.W.U.S. (Teaclock-Wakeupclock-Userclock-Stopclock) and my Trading-crown-caps :-)

Please send suggestions and bug reports to info@twus.de.


FAQ

FAQ: SCAN_KK [image] [image] (c) by Mike ;-)

Frequently-Asked-Questions:

1. I try to acquire greyscale pictures - with scary results?
Scan_KK only supports colo(u)r scans in the moment!

2. Sometimes the preview picture rotates?
If the preview window is still closed and the point, where the user double
clicks the bitmap, lies where the preview window accidentally opens, this effect
will show, because Windows sends the double click message to the preview window
also, which results in a left rotation. (=> solved since version V1.06).

3. Sometimes colored areas appear in the preview window?
Scan_KK works internally with a buffer 2x the size of the preview window.
If the preview picture is moved too far, the colored loneliness of the memory
will show up ;-) (The color depends on the settings for the border fill color).

4. After rotation and movement the picture makes a litte jump?
Through the internals since V1.06 (better performance on slow PC) and small calculation errors
the picture can sometimes do a little jumping.

5. Can I use different positions for each of the 3 presets?
Scan_KK will make no difference between the 3 presets. If "Remember Pos." is selected
(under "settings"), on restart Scan_KK will use the window size and position when Scan_KK
was closed. If "Remember Pos." is not selected, Scan_KK will start in full screen mode.

6. Why do I have to restart Scan_KK in Vista/Windows 7/Windows 8/Windows 10/Windows 11 by hand after a language change?
Could happen with older Scan_KK versions. Should not happen nowadays. It had to do with the access rights.

7. Why do I need admin credentials under Windows Vista/Windows 7/Windows 8/Windows 10/Windows 11?
They are needed for the setup program.
Tries without admin credientials for the setup lead to problems. In case the setup was started with "Run as Administrator"
everything was installed for the Administrator and not for the logged in user.

8. Why does the picture look unsharp during rotation?
For performance reasons the picture is sharpened only once - when the user releases the right
mouse button. Another click into the preview picture (without moving the mouse too much) sharpens the picture again.

9. Why does my antivir software sound an alarm?
That is an known and tiresome problem for many freeware developers. False alarms of their software will only be
corrected very slowly by the antivir firms.
All files of Scan_KK have been checked before delivery successfully on Virustotal (www.virustotal.com).

10. Why isn't the program / the updater not signed?
Because I only develop freeware, the yearly costs for a valid signature are too high for me.

11. UAC questions
If the user has no administrator rights and the UAC (User Access Control) is not deactivated, Window
(from Windows Vista on) will present an dialog to log on as administrator when the installer program is started.
Please sign on there as an administrator or the installation of the update will fail.
Is the UAC deativated, no dialog will pop up and the later installation of the update will fail!
It is possible to continue the update without any administrator rights until after the download of the
setup file and to later install it under an administrator account. In this case it is advisable to use the detailed mode
to see where the setup file is saved on the PC.

12. Select "Fit pictures to window" or "Preview of too big pictures"?
Selecting "Fit pictures to window" should be checked, because in this case the complete picture is visible.
"Preview of too big pictures" should be deselected. But give it a try! Open a big picture and hover the mouse pointer
over "<< *.bmp (x/y) >>" and see what happens ;-)

13. Which scan setting shall be used?
To cut out caps in the right size, they have to be scanned with 150 DPI and to be cut with about 180x180 pixel.
That results in a bad picture for some caps (Moire Effect).
I do the scan with 600 DPI, reduce the size in a graphic program to 25% (in each axis), so that 180x180 pixel
cut out the cap in the right size. At 300 DPI you have to reduce the size to 50%.
If you scan inside of Scan_KK (Acquisition) the size reduction can be set (under "settings")
(Scan-Input: new size as percentage of original).


Credits

Credits: SCAN_KK [image] [image] (c) by Mike ;-)

Development tools: "Pelles C for Windows" in version 11.00.2 ( Homepage Pelle Orinius ).

Scan_KK uses graphic routines of the FreeImage Open Source Graphic Library Version 3.18.0. (see freeimage.sourceforge.net )
according to the FreeImage public license - version 1.0 (see file license-fi.txt in the installation directory of Scan_KK).

Scan_KK uses InnoSetup 6.2.1 (www.jrsoftware.org) for the installation process.

Scan_KK scanner support is based on the work of the TWAIN working group.

 A heartly thanks goes to the following persons:
Rudi, Kamil (tips)
Elke, Carsten (test support)
Harald, Günther (crown caps)
 Kimmo (tips)
Nils and Jürgen (caps and bug reports)
Eckhard (ideas and caps)